/*
   _===_ _           _                  ______ _     _             _ _ _
  |  ___| |         | |                 | ___ (_)   | |           (_) | |
  | |__ | | ___  ___| |_ _ __ ___ ______| |_/ /_  __| | ___  _   _ _| | | ___ _   _ _ __
  |  __|| |/ _ \/ __| __| '__/ _ \______| ___ \ |/ _` |/ _ \| | | | | | |/ _ \ | | | '__|
  | |___| |  __/ (__| |_| | | (_) |     | |_/ / | (_| | (_) | |_| | | | |  __/ |_| | |
  \____/|_|\___|\___|\__|_|  \___/      \____/|_|\__,_|\___/ \__,_|_|_|_|\___|\__,_|_|

  Démo de lecture des 8 bits d,un PCF8574 (GPIO Expander)
  Électro-Bidouilleur, Avril 2022. https://www.youtube.com/Électro-Bidouilleur
  Licence de droits: Attribution 4.0 International (CC BY 4.0)  Lisez https://creativecommons.org/licenses/by/4.0/deed.fr  
*/

#include "PCF8574.h"

PCF8574 Bus_8b(0x20);                           // Instanciation du PCF8574

// Fonction d'initialisation, style arduino
void setup()
{
  Bus_8b.begin();                               // Initialisation du bus I2C
  Serial.begin(115200);                         // Initialisation du port UART vers l'ordi
} 

// Fonction de bouclage perpétuel, style arduino
void loop()
{
    String char8 = "";                          // La chaîne de caractères 0/1 à afficher
    unsigned char val8 = Bus_8b.read8();        // Lecture des bits GPIO du PCF8574
    for (int ctr = 7; ctr >= 0; ctr--)          // Boucle de création de l'affichage des 8 bits
    {
      char8 += String((val8>>ctr) & 1);         // Addition d'un caractère "0" ou "1" à la chaîne de caractères
    }
    Serial.println(char8);                      // Impression de la chaîne de caractères complète.
}

//  // Plus simple
//  void loop()
//  {
//    Serial.println(Bus_8b.read8(), BIN);        // Lecture et impression combinée. Les "0" à gauche ne sont pas affichés
//  }
